# set up a slave gm_allsize on the destination_node
# gm_allsize --slave --size=20
# then run on the local node
# gmperf.pl <destination_node> [size [local_board [gm_allsize_params]]]

if [ $# = 0 ]
then
	echo usage: $0 \<dest-node\> \[size \[local_board \[gm_allsize_params\]\]\]
	exit 1
fi
desthost=$1
parms=$#
if [ $parms -gt 1 ]
then
	shift
	size=$1
else
	size=20
fi
if [ $parms -gt 2 ]
then
	shift
	lboard=$1
else
	lboard=0
fi
shift
echo Parameters ...
echo $desthost
echo $size
echo $lboard
echo $*

cmd="./gm_debug -L -B $lboard"
echo $cmd
$cmd > $desthost.gm_debug

cmd="./gm_board_info -B $lboard
echo $cmd
$cmd > $desthost.gm_board_info";

cmd="./gm_allsize -B $lboard --size=$size -h $desthost -lat -b --geometric -o $desthost.lat.b.gpl $* ";
echo $cmd
$cmd

cmd="./gm_allsize -B $lboard --size=$size -h $desthost -lat -u --geometric -o $desthost.lat.u.gpl $* ";
echo $cmd
$cmd

cmd="./gm_allsize -B $lboard --size=$size -h $desthost -bw -b --geometric -o $desthost.bw.b.gpl $* ";
echo $cmd
$cmd

cmd="./gm_allsize -B $lboard --size=$size -h $desthost -bw -u --geometric -o $desthost.bw.u.gpl $* ";
echo $cmd
$cmd

echo "\n\nCompleted GM tests.\n";
