/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation			 *
 * Copyright (c) 2002 by Myricom, Inc.					 *
 * All rights reserved.	 See the file `COPYING' for copyright notice.	 *
 *************************************************************************/

/* author: gallatin@myri.com */

#ifndef _gm_arch_io_h_
#define _gm_arch_io_h_

#include <sys/ioccom.h>		/* defines ioctl code packing */

/*
 * For ioctls.  The driver's ioctl handler dumbs-down the BSD ioctl
 * method & lets the higher level function call copyin/copyout as if 
 * we were a sysv style system
 */

#define GM_IO(n)        _IO('G',(n))

/*
 * MAC OS X doesn't support mmap on device files, so we need to do it
 * ourselves
 */

typedef struct gm_mmap_info
{
  gm_u32_t offset;		/* offset to map */
  gm_u32_t len;			/* length to map */
  unsigned int requested_permissions;	/* GM_MAP_READ/GM_MAP_WRITE */
  void *va;			/* Virtual address hint */
}
gm_mmap_info_t;



/*
  This file uses GM standard indentation:

  Local Variables:
  c-file-style:"gnu"
  tab-width:8
  c-backslash-column:72
  End:
*/

#endif /* _gm_arch_io_h_ */
