/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation                      *
 * Copyright (c) 1996, 1997, 1998 by Myricom, Inc.                       *
 * All rights reserved.  See the file `COPYING' for copyright notice.    *
 *************************************************************************/

#include "gm_internal.h"
#include "gm_io.h"
#include "gm_lanai_command.h"

#if GM_KERNEL
#include "gm_enable_security.h"
#include "gm_pio.h"
#include "gm_debug.h"
#endif

GM_ENTRY_POINT
gm_status_t
_gm_clear_counters (gm_port_t *p)
{
#if GM_KERNEL
  gm_port_state_t *ps = p->kernel_port_state;
  gm_instance_state_t *is = ps->instance;

  gm_status_t status;

  if (!is->lanai.running) {
    GM_PRINT (GM_PRINT_LEVEL >= 4, ("_gm_clear_counters: lanai.running is false\n"));
    return GM_UNATTACHED;
  }
  
  GM_PRINT (GM_PRINT_LEVEL >= 5, ("Clearing counters\n"));
	
  /* Execute command, guarded by command_sync */
  gm_arch_mutex_enter (&is->command_sync);
  status = gm_lanai_command(is, GM_LANAI_COMMAND_CLEAR_COUNTERS);
  gm_arch_mutex_exit (&is->command_sync);
  
  return status;

#else
  {
    unsigned int u;
    /* this is just a dummy variable to help out osf1 ioctl problems */
    return _gm_user_ioctl (p, GM_CLEAR_COUNTERS, &u, sizeof(unsigned int));
  }
#endif
}
