/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation                      *
 * Copyright (c) 1996, 1997 by Myricom, Inc.                             *
 * All rights reserved.  See the file `COPYING' for copyright notice.    *
 *************************************************************************/

#include "gm_call_trace.h"
#include "gm_debug.h"
#include "gm_internal.h"

#if GM_KERNEL
#include "gm_enable_security.h"
#include "gm_pio.h"
#endif

#define GM_DEBUG_SET_NODE_ID 0

#if GM_DEBUG_SET_NODE_ID
#undef GM_LOCALLY_ENABLE_CALL_TRACE
#define GM_LOCALLY_ENABLE_CALL_TRACE 1
#endif

GM_ENTRY_POINT
gm_status_t
_gm_set_node_id (struct gm_port *port, unsigned int node_id)
{
  gm_status_t status;
  unsigned int this_node_id;
  
  /* For limited backwards compatibility, allow this function to
     be called, but require that the node ID does not change. */

  GM_CALLED_WITH_ARGS_EX
    (GM_DEBUG_SET_NODE_ID,
     ("%p,0x%x", port, node_id));
  
  /* Read the node ID. */

  status = gm_get_node_id (port, &this_node_id);
  if (status != GM_SUCCESS)
    {
      GM_RETURN_STATUS (status);
    }

  /* Verify that the input node ID is the same as the existing one. */
  
  if (node_id != this_node_id)
    {
      GM_RETURN_STATUS (GM_INVALID_PARAMETER);
    }
  GM_RETURN_STATUS (GM_SUCCESS);
}

