/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation                      *
 * Copyright (c) 1996, 1997 by Myricom, Inc.                             *
 * All rights reserved.  See the file `COPYING' for copyright notice.    *
 *************************************************************************/

/* author: glenn@myri.com */

#include "gm_call_trace.h"
#include "gm_debug.h"
#include "gm_internal.h"

/* Tell the driver the port number to be associated with this port. */

#define GM_DEBUG_SET_PORT_NUM 0

#if GM_DEBUG_SET_PORT_NUM
#undef GM_LOCALLY_ENABLE_CALL_TRACE
#define GM_LOCALLY_ENABLE_CALL_TRACE 1
#endif

gm_status_t
_gm_set_port_num (gm_port_t * port, unsigned long _id)
{
  gm_status_t status;
  
  GM_CALLED_WITH_ARGS (("%p,%lu", port, _id));
#if GM_KERNEL
  {
    /* _gm_set_port_num not supported in kernel.  Must be intercepted in
       gm_arch.c */
    status = GM_NOT_SUPPORTED_IN_KERNEL;
  }
#else /* in userland */
  {
    gm_u32_t id;

    id = _id;
    if (id >= GM_NUM_PORTS)
      GM_RETURN_STATUS (GM_INVALID_PORT_NUMBER);
    GM_PRINT (GM_DEBUG_SET_PORT_NUM,
	      ("_gm_set_port_num: setting port number to %d.\n", id));
    status = _gm_user_ioctl (port, GM_SET_PORT_NUM, &id, sizeof (id));
    GM_PRINT (GM_DEBUG_SET_PORT_NUM,
	      ("_gm_set_port_num: set port number (or failed to).\n"));
  }
#endif /* in userland */
  GM_RETURN_STATUS (status);
}

/*
  This file uses GM standard indentation:

  Local Variables:
  c-file-style:"gnu"
  tab-width:8
  End:
*/
