/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation                      *
 * Copyright (c) 1996, 1997 by Myricom, Inc.                             *
 * All rights reserved.  See the file `COPYING' for copyright notice.    *
 *************************************************************************/

#include "gm_call_trace.h"
#include "gm_internal.h"

#if GM_KERNEL
#include "gm_pio.h"
#include "gm_debug.h"
#endif

#define GM_DEBUG_SET_UNIQUE_ID 0

/* Since there is now a fixed relationship between node ID's and
   unqiue ID's, this function simply confirms that relationship. */

GM_ENTRY_POINT
gm_status_t
_gm_set_unique_id (gm_port_t *port, unsigned int node_id, char unique[6])
{
  gm_status_t status;
  unsigned int check_node_id;
  
  GM_CALLED_WITH_ARGS_EX
    (GM_DEBUG_SET_UNIQUE_ID,
     ("%p,%u,%02x:%02x:%02x:%02x:%02x:%02x",
      port, node_id,
      unique[0], unique[1], unique[2], unique[3], unique[4], unique[5]));
  
  /* Convert the unique ID to a node ID. */
  
  status = gm_unique_id_to_node_id (port, unique, &check_node_id);
  if (status != GM_SUCCESS)
    {
      GM_RETURN_STATUS (status);
    }

  /* Confirm that the node ID passed in is consistent with the unique ID. */

  if (node_id != check_node_id)
    {
      GM_RETURN_STATUS (GM_INVALID_PARAMETER);
    }

  GM_RETURN_STATUS (GM_SUCCESS);
}
