/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation                      *
 * Copyright (c) 1996, 1997 by Myricom, Inc.                             *
 * All rights reserved.  See the file `COPYING' for copyright notice.    *
 *************************************************************************/

/**
   @file gm_abort.c
*/

#include "gm_config.h"
#include "gm_debug.h"
#include "gm_internal.h"

#if STDC_HEADERS && !GM_KERNEL
#include <stdlib.h>
#include <stdio.h>
void abort (void);
#endif

/**
   gm_abort() aborts the current process, and is a wrapper
   around the system function abort().
 
   @see gm_init gm_open gm_close gm_exit gm_finalize
 
   @author Glenn Brown
 
   @version GM_API_VERSION (as defined in gm.h)
*/

GM_ENTRY_POINT void
gm_abort ()
{
#if GM_KERNEL
  gm_arch_abort ();
  gm_exit (GM_ABORTED);
#elif defined WIN32
  /* Keep Windows from popping up a useless and annoying dialog box if the
     program fails. */
  GM_WARN (("Program aborted.\n"));
  gm_exit (GM_ABORTED);
#elif GM_BUILDING_FIRMWARE
  GM_WARN (("Program aborted.\n"));
  fflush (stdout);
  while (1)
    {
      gm_morse_sync ("SOS\n");
    }
#else
  abort ();
#endif
}
