/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation                      *
 * Copyright (c) 1996, 1997 by Myricom, Inc.                             *
 * All rights reserved.  See the file `COPYING' for copyright notice.    *
 *************************************************************************/

/**
   @file gm_allow_remote_memory_access.c
*/

#include "gm_internal.h"

/**
   gm_allow_remote_memory_access() allows any remote GM port to
   modify the contents of any GM DMAable memory using the gm_directed_send()
   function.  This is a significant security hole, but is very useful
   on tightly coupled clusters on trusted networks.
 
   @retval GM_SUCCESS Operation completed successfully.
 
   @param port \b (IN) Handle to the GM port.
 
   @author Glenn Brown
 
   @version GM_API_VERSION (as defined in gm.h)
 
*/

GM_ENTRY_POINT gm_status_t
gm_allow_remote_memory_access (struct gm_port *port)
{
  /* This function is no longer needed.  Previously, it supplied some
     special receive tokens to the LANai that were used to handle
     misaligned PUTs, but that's not longer required because all
     LANais supported now include byte DMA. */
  return GM_SUCCESS;
}

/*
  This file uses GM standard indentation:

  Local Variables:
  c-file-style:"gnu"
  tab-width:8
  End:
*/
