/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation			 *
 * Copyright (c) 2000 by Myricom, Inc.					 *
 * All rights reserved.	 See the file `COPYING' for copyright notice.	 *
 *************************************************************************/

/* author: glenn@myri.com */

#include "gm.h"
#include "gm_internal_funcs.h"

#define BCOPY3() *--t = a; a = *--f; *--t = b; b = *--f; *--t = c; c = *--f;

/* Just like bcopy, but copy the bytes in reverse order */

void
_gm_bcopy_down (const void *from, void *to, unsigned long len)
{
  char *f, *t, *limit;
  char a, b, c;

  f = (char *) from + len;
  t = (char *) to + len;
  limit = (char *) to;

  a = *--f;
  b = *--f;
  c = *--f;
  switch (len & 15)
    {
    case 0:
      while (t != limit)
	{
	  BCOPY3 ();
    case 13:
	  BCOPY3 ();
    case 10:
	  BCOPY3 ();
    case 7:
	  BCOPY3 ();
    case 4:
	  BCOPY3 ();
    case 1:
	  if (t - 1 == limit)
	    {
	      *--t = a;
	      return;
	    }
	  BCOPY3 ();
    case 14:
	  BCOPY3 ();
    case 11:
	  BCOPY3 ();
    case 8:
	  BCOPY3 ();
    case 5:
	  BCOPY3 ();
    case 2:
	  if (t - 2 == limit)
	    {
	      *--t = a;
	      *--t = b;
	      return;
	    }
	  BCOPY3 ();
    case 15:
	  BCOPY3 ();
    case 12:
	  BCOPY3 ();
    case 9:
	  BCOPY3 ();
    case 6:
	  BCOPY3 ();
    case 3:
	  BCOPY3 ();
	}
    }
}

#undef BCOPY3

