/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation                      *
 * Copyright (c) 1996, 1997 by Myricom, Inc.                             *
 * All rights reserved.  See the file `COPYING' for copyright notice.    *
 *************************************************************************/

/**
   @file gm_calloc.c
*/

#if !GM_KERNEL
#include <stdlib.h>
#endif

#include "gm_call_trace.h"
#include "gm_internal.h"
#include "gm_malloc_debug.h"

/**
   gm_calloc() allocates and clears an array of \b cnt elements
   of length \b len.
 
   @param len \b (IN) The number of bytes in each element.
 
   @param cnt \b (IN) The number of elements in the array.
 
   @author Glenn Brown
 
   @version GM_API_VERSION (as defined in gm.h)
 
*/

GM_ENTRY_POINT
void *
gm_calloc (gm_size_t len, gm_size_t cnt)
{
  void *ret;

  GM_CALLED ();
  len *= cnt;
  ret = gm_malloc (len);
  if (!ret)
    {
      GM_RETURN (0);
    }
  gm_bzero (ret, len);
  GM_RETURN (ret);
}
