/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation                      *
 * Copyright (c) 1996, 1997 by Myricom, Inc.                             *
 * All rights reserved.  See the file `COPYING' for copyright notice.    *
 *************************************************************************/

#include "gm_call_trace.h"
#include "gm_cpp.h"
#include "gm_debug.h"
#include "gm_debug_ethernet.h"
#include "gm_enable_ethernet.h"
#include "gm_ether.h"
#include "gm_internal.h"

#define GM_DEBUG_ETHERNET_PROVIDE_SCATTER_LIST 0

#if GM_DEBUG_ETHERNET_PROVIDE_SCATTER_LIST
#undef GM_LOCALLY_ENABLE_CALL_TRACE
#define GM_LOCALLY_ENABLE_CALL_TRACE 1
#endif

void
gm_ethernet_provide_scatter_list_with_tag (gm_port_t * p,
					   gm_u32_t segment_cnt,
					   gm_ethernet_segment_descriptor_t 
					   segment[],
					   gm_u8_t tag)
{
  GM_CALLED ();
#if GM_ENABLE_ETHERNET
  {
    gm_ethernet_scatter_list_n_t *pos;
    unsigned int i;
    gm_dp_t dma_addr;
    unsigned int total_len = 0;

    pos = p->ethernet->scatter.list[tag].ptr;
    dma_addr = p->ethernet->scatter.list[tag].dma_addr;

    GM_PRINT (GM_DEBUG_ETHERNET_PROVIDE_SCATTER_LIST,
	      ("user provide ethernet scatter list:\n"));
    for (i=0; i<segment_cnt; i++)
      {
	gm_dp_t ptr;
	unsigned int len;

	ptr = segment[i].ptr;
	len = segment[i].len;
	_GM_PRINT (GM_DEBUG_ETHERNET_PROVIDE_SCATTER_LIST,
		   ("%d:%d  "GM_U64_TMPL",%u\n", tag,
		    i, GM_U64_ARG(ptr), len));
	(*pos)[i].ptr = gm_hton_dp (ptr);
	(*pos)[i].len = gm_hton_u32 (len);
	total_len += len;
      }
    _GM_PRINT (GM_DEBUG_ETHERNET_PROVIDE_SCATTER_LIST,
	       ("total_len=%u\n", total_len));
    gm_assert (total_len >= GM_ETHERNET_MTU);
    gm_provide_receive_buffer_with_tag (p, pos, GM_ETHERNET_TAG_SIZE,
					GM_LOW_PRIORITY, (gm_u32_t)tag);
  }
#endif /* GM_ENABLE_ETHERNET */
  GM_RETURN_NOTHING ();
}



/*
  This file uses GM standard indentation.

  Local Variables:
  c-file-style:"gnu"
  tab-width:8
  End:
*/
