/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation                      *
 * Copyright (c) 1996, 1997 by Myricom, Inc.                             *
 * All rights reserved.  See the file `COPYING' for copyright notice.    *
 *************************************************************************/

/**
   @file gm_flush_alarm.c
   This file contains the GM API function gm_flush_alarm().
*/

#include "gm_call_trace.h"
#include "gm_internal.h"
#include "gm_send_queue.h"

#define GM_DEBUG_FLUSH_ALARM 0

#if GM_DEBUG_FLUSH_ALARM
#undef GM_LOCALLY_ENABLE_CALL_TRACE
#define GM_LOCALLY_ENABLE_CALL_TRACE 1
#endif

/**
   gm_flush_alarm() flushes the alarm queue.
 
   @param p \b (IN) The GM port.
 
   @see gm_set_alarm gm_initialize_alarm gm_cancel_alarm
 
   @author Glenn Brown
 
   @version GM_API_VERSION (as defined in gm.h)
 
*/

GM_ENTRY_POINT
void
gm_flush_alarm (gm_port_t * p)
{
  GM_CALLED_WITH_ARGS (("%p", p));

  /* pass a flush event to lanai in the send token queue */

  __gm_post_simple_send_event (p, GM_FLUSH_ALARM_EVENT);

   /* update state and return */

  p->lanai_alarm_state = LANAI_ALARM_FLUSHING;
  p->alarm_token_cnt--;

  GM_RETURN_NOTHING ();
}


