/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation                      *
 * Copyright (c) 1996, 1997 by Myricom, Inc.                             *
 * All rights reserved.  See the file `COPYING' for copyright notice.    *
 *************************************************************************/

/**
   @file gm_free_send_token.c
   This file contains the GM API function gm_free_send_token().
*/

#include "gm_internal.h"
#include "gm_send_queue.h"

/**
   gm_free_send_token() increments a free send token of
   \b priority for \b port so that it can later be allocated using
   gm_alloc_send_token().  Clients may choose to maintain their
   own count of send tokens in the client's possession instead of
   using this utility function.
 
   @param p
   @param priority
 
   @see gm_alloc_send_token gm_free_send_tokens
 
   @author Glenn Brown
 
   @version GM_API_VERSION (as defined in gm.h)
 
*/

GM_ENTRY_POINT
void
gm_free_send_token (gm_port_t * p, unsigned priority)
{
  __gm_free_send_tokens (p, priority, 1);
}
