/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation                      *
 * Copyright (c) 1996, 1997 by Myricom, Inc.                             *
 * All rights reserved.  See the file `COPYING' for copyright notice.    *
 *************************************************************************/

#include "gm_internal.h"
#include "gm_mapper_state.h"

#if GM_KERNEL
#include "gm_enable_security.h"
#include "gm_pio.h"
#include "gm_debug.h"
#endif

GM_ENTRY_POINT
gm_status_t
_gm_get_mapper_state (gm_port_t *port,
		      struct gm_mapper_state *mapper_state)
{
#if GM_KERNEL
  gm_port_state_t *ps = port->kernel_port_state;
  gm_instance_state_t *is = ps->instance;

  return gm_copyout (ps, &is->mapper_state, mapper_state,
		     sizeof (*mapper_state));
#else
  return _gm_user_ioctl (port, GM_GET_MAPPER_STATE, mapper_state,
			 sizeof (*mapper_state));
#endif
}
