/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation                      *
 * Copyright (c) 1996, 1997 by Myricom, Inc.                             *
 * All rights reserved.  See the file `COPYING' for copyright notice.    *
 *************************************************************************/

/**
   @file gm_get_node_id.c
   This file contains the GM API function gm_get_node_id.c
*/

#include "gm_internal.h"

#if GM_KERNEL
#include "gm_pio.h"
#include "gm_debug.h"
#endif

/**
   gm_get_node_id() copies the GM ID of the network interface
   card associated with \b port to the address \b node_id.
 
   @retval GM_SUCCESS Operation completed successfully
   @retval GM_NODE_ID_NOT_YET_SET The GM node ID has not been set.
 
   @param port \b (IN) The GM port.
   @param node_id  \b (OUT) Address to copy the GM ID.
 
   @author Glenn Brown
 
   @version GM_API_VERSION (as defined in gm.h)
 
*/

GM_ENTRY_POINT gm_status_t
gm_get_node_id (gm_port_t *port, unsigned int *node_id)
{
  /* The local loopback node ID is always 1. */
  *node_id = 1;
  return GM_SUCCESS;
}
