/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation                      *
 * Copyright (c) 1996, 1997 by Myricom, Inc.                             *
 * All rights reserved.  See the file `COPYING' for copyright notice.    *
 *************************************************************************/

#include "gm_debug.h"
#include "gm_internal.h"

#if GM_KERNEL
#include "gm_pio.h"
#endif


GM_ENTRY_POINT gm_status_t
gm_get_opiom_data_addr(struct gm_port *port, gm_up_t *addr)
{
#if GM_ENABLE_OPIOM

#if GM_KERNEL
  gm_instance_state_t *is;
  gm_port_state_t *ps;
  
  gm_assert (port);
  ps = port->kernel_port_state;
  gm_assert (ps);
  is = ps->instance;
  gm_assert (is);
  gm_assert (is->lanai.globals);

  // get the PCI memory
  // specific for linux/PC (phys_base = bus_base)
  *addr = ps->instance->arch.phys_base_addr;
  
  // get the offset relative to the lanai memory
  *addr += (gm_up_t) ((gm_lanai_globals_t*)is->lanai.globals)->opiom_data;
  *addr -= (gm_up_t) ps->instance->board_base;

  GM_PRINT (GM_PRINT_LEVEL >= 4,
            ("gm_get_opiom_data_addr: returning opiom address = %p.\n",
	     addr));
  return GM_SUCCESS;
#else
  gm_status_t status;

  status = _gm_user_ioctl (port, GM_GET_OPIOM_DATA_ADDR,
                           addr, sizeof (gm_up_t));
  return status;
#endif

#else /* GM_ENABLE_OPIOM */

  return GM_FAILURE;

#endif /* GM_ENABLE_OPIOM */  
}
