/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation			 *
 * Copyright (c) 2000 by Myricom, Inc.					 *
 * All rights reserved.	 See the file `COPYING' for copyright notice.	 *
 *************************************************************************/

/**
   @file gm_isprint.c
   The file containing the GM API function gm_isprint().
*/

#include "gm_internal.h"

/**
 
   gm_isprint() is just like ANSI isprint(), only it works in the kernel
   and MCP.
 
   @retval int The return value is nonzero if the character is
               a printable character including a space, and a zero
               value if not.
 
   @param c \b (OUT)  Printable character.
 
   @author Glenn Brown
 
   @version GM_API_VERSION (as defined in gm.h)
 
*/
 
int
gm_isprint (int c)
{
  return (c >= ' ' && c <= '~');
}

/*
  This file uses GM standard indentation:

  Local Variables:
  c-file-style:"gnu"
  tab-width:8
  c-backslash-column:72
  End:
*/
