/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation                      *
 * Copyright (c) 1996, 1997 by Myricom, Inc.                             *
 * All rights reserved.  See the file `COPYING' for copyright notice.    *
 *************************************************************************/

/**
   @file gm_max_length_for_size.c
   This file contains the GM API function gm_max_length_for_size().
*/

#include "gm_internal.h"
#include "gm_types.h"		/* for GM_MAX_LENGTH_FOR_SIZE() */

/**
   gm_max_length_for_size() returns the maximum length of a message
   that will fit in a GM buffer of size \b size.
 
   @retval gm_size_t
 
   @param size \b (IN) The size of the GM buffer.
 
   @author Glenn Brown
 
   @version GM_API_VERSION (as defined in gm.h)
 
*/

GM_ENTRY_POINT
gm_size_t
gm_max_length_for_size (unsigned int size)
{
  return GM_MAX_LENGTH_FOR_SIZE (size);
}
