/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation                      *
 * Copyright (c) 1996, 1997 by Myricom, Inc.                             *
 * All rights reserved.  See the file `COPYING' for copyright notice.    *
 *************************************************************************/

/**
   @file gm_memset.c
*/

#include "gm_config.h"
#include "gm.h"

/**
   gm_memset() reimplements the UNIX function memset(). 
 
   @retval void Returns a pointer to the memory area s.
 
   @param s (IN) The memory area.

   @param c (IN) The constant byte size.

   @param n (IN) The number of bytes.
 
   @author Glenn Brown
 
   @version GM_API_VERSION (as defined in gm.h)
 
*/

GM_ENTRY_POINT
void *
gm_memset (void *s, int c, gm_size_t n)
{
  char *to;

  for (to=(char *)s; n; n--)
    {
      *to++ = (char) c;
    }
  return s;
}
