/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation                      *
 * Copyright (c) 1996, 1997 by Myricom, Inc.                             *
 * All rights reserved.  See the file `COPYING' for copyright notice.    *
 *************************************************************************/

/**
   @file gm_min_message_size.c
   This file contains the GM API function gm_min_message_size().
*/

#include "gm_compiler.h"
#include "gm_internal.h"

/**
   gm_min_message_size() returns the minimum supported message size.  This
   value is accessed through the function API to avoid hard-coding it in
   user applications, allowing dynamic library upgrades.
 
   @retval GM_MIN_MESSAGE_SIZE
 
   @param p
 
   @author Glenn Brown
 
   @version GM_API_VERSION (as defined in gm.h)
 
*/

GM_ENTRY_POINT
unsigned int
gm_min_message_size (gm_port_t *p)
{
  GM_PARAMETER_MAY_BE_UNUSED (p);
  
  return GM_MIN_MESSAGE_SIZE;
}
