/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation                      *
 * Copyright (c) 1996, 1997 by Myricom, Inc.                             *
 * All rights reserved.  See the file `COPYING' for copyright notice.    *
 *************************************************************************/

/**
   @file gm_min_size_for_length.c
   This file contains the GM API function gm_min_size_for_length().
*/

#include "gm_internal.h"

/**
   gm_min_size_for_length() returns the minimum GM message buffer
   size required to store a message of length \b length.
 
   @retval gm_log2_roundup
 
   @param length \b (IN) The length of the message.
 
   @author Glenn Brown
 
   @version GM_API_VERSION (as defined in gm.h)
 
*/

GM_ENTRY_POINT
unsigned int
gm_min_size_for_length (gm_size_t length)
{
  return (unsigned int) gm_log2_roundup ((unsigned long) length + 8);
}
