/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation                      *
 * Copyright (c) 1996, 1997 by Myricom, Inc.                             *
 * All rights reserved.  See the file `COPYING' for copyright notice.    *
 *************************************************************************/

/**
   @file gm_num_ports.c
   This file contains the GM API function gm_num_ports().
*/

#include "gm_compiler.h"
#include "gm_internal.h"


/**
   gm_num_ports() returns the number of ports supported by this build.
   Note that this is a build-time value, and the 'p' parameter is actually
   meaningless at the present time.
 
   This value is accessed through the function API to avoid hard-coding it in
   user applications, thus allowing dynamic library upgrades.
 
   @retval GM_NUM_PORTS
 
   @param p \b (IN) The GM port.
 
   @author Glenn Brown
 
   @version GM_API_VERSION (as defined in gm.h)
 
*/

GM_ENTRY_POINT
unsigned int
gm_num_ports (gm_port_t *p)
{
  GM_PARAMETER_MAY_BE_UNUSED (p);
  
  return GM_NUM_PORTS;
}
