/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation                      *
 * Copyright (c) 1996, 1997 by Myricom, Inc.                             *
 * All rights reserved.  See the file `COPYING' for copyright notice.    *
 *************************************************************************/

/**
   @file gm_num_receive_tokens.c
   This file contains the GM API function gm_num_receive_tokens().
*/

#include "gm_compiler.h"
#include "gm_debug.h"
#include "gm_internal.h"

#define GM_DEBUG_NUM_RECV_TOKENS 0

/**
   gm_num_receive_tokens() returns the number of receive tokens for this port.
   This value is accessed through the function API to avoid hard-coding it
   in user applications, allowing dynamic library upgrades.
 
   @retval GM_NUM_RECV_TOKENS
 
   @param p \b (IN) The GM port.
 
   @author Glenn Brown
 
   @version GM_API_VERSION (as defined in gm.h)
 
*/

GM_ENTRY_POINT
unsigned int
gm_num_receive_tokens (gm_port_t *p)
{
  unsigned int ret;
  GM_PARAMETER_MAY_BE_UNUSED (p);
  
  ret = GM_NUM_RECV_TOKENS;
  GM_PRINT (GM_DEBUG_NUM_RECV_TOKENS,
	    ("returning %d\n", ret));
  return ret;
}
