/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation                      *
 * Copyright (c) 1996, 1997 by Myricom, Inc.                             *
 * All rights reserved.  See the file `COPYING' for copyright notice.    *
 *************************************************************************/

#include "gm_debug.h"
#include "gm_internal.h"

#if !GM_KERNEL
#include <stdlib.h>
#endif


GM_ENTRY_POINT gm_opiom_segment_t *
gm_opiom_malloc(struct gm_port *port, gm_u32_t size)
{
#if GM_ENABLE_OPIOM

#if GM_KERNEL
  gm_opiom_segment_t * seg;
  
  _gm_opiom_malloc(size, &seg);
  GM_PRINT (GM_PRINT_LEVEL >= 4,
            ("gm_opiom_malloc: returning opiom address = %p.\n",
             seg));
  return seg;
#else
  gm_status_t status;
  gm_u64_t addr;

  addr = size;
  status = _gm_user_ioctl (port, GM_OPIOM_MALLOC,
                           &addr, sizeof (gm_u64_t));
  if (status != GM_SUCCESS)
    return (gm_opiom_segment_t *)0;
  else
    return (gm_opiom_segment_t *)addr;
#endif

#else /* GM_ENABLE_OPIOM */

  return (gm_opiom_segment_t*)0;
#endif /* GM_ENABLE_OPIOM */
}


GM_ENTRY_POINT void 
gm_opiom_free(struct gm_port *port, gm_opiom_segment_t * seg)
{
#if GM_ENABLE_OPIOM
#if GM_KERNEL
  GM_PRINT (GM_PRINT_LEVEL >= 4,
            ("gm_opiom_free: freeing opiom address = %p.\n",
             seg));
  _gm_opiom_free(seg);
#else
  gm_status_t status;
  status = _gm_user_ioctl (port, GM_OPIOM_FREE,
                           &seg, sizeof (gm_opiom_segment_t*));
#endif
#endif /* GM_ENABLE_OPIOM */
}
