/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation                      *
 * Copyright (c) 1996, 1997 by Myricom, Inc.                             *
 * All rights reserved.  See the file `COPYING' for copyright notice.    *
 *************************************************************************/

/**
   @file gm_receive_pending.c
   This file contains the GM API function gm_receive_pending().
*/

#include "gm_internal.h"

/**
   gm_receive_pending() returns nonzero if a receive event is pending.
   If a receive event is pending, a call to any gm_receive*() function
   will return the event immediately, although gm_receive()
   is preferred in this case for efficiency.
 
   @retval event.recv.type
 
   @param p \b (IN) The GM port for which the received communication is
            pending.
 
   @see gm_receive
 
   @author Glenn Brown
 
   @version GM_API_VERSION (as defined in gm.h)
 
*/

GM_ENTRY_POINT
int
gm_receive_pending (gm_port_t *p)
{
  int ret;

  ret = (gm_ntoh_u8 (p->recv_queue_slot->event.recv.type) >= 128);
  return ret;
}

