/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation			 *
 * Copyright (c) 2003 by Myricom, Inc.					 *
 * All rights reserved.	 See the file `COPYING' for copyright notice.	 *
 *************************************************************************/

/* author: glenn@myri.com */

/* This file reference all GM entry points, and can be used to ensure that
   all entry points are pulled into a driver or library. */

#include "gm_enable_datagrams.h"
#include "gm_config.h"

/****************
 * Linux
 ****************/

#if GM_OS_LINUX && GM_KERNEL
#include <linux/module.h>
#define GM_REF(a) EXPORT_SYMBOL (a)

/****************
 * Other OS's
 ****************/

#else
#define GM_REF(a)							\
extern void *__gm_reference_ ## a;					\
void *__gm_reference_ ## a = (void *) &a
#endif

/* Generate references to every GM API entry point. */

#include "gm.h"
GM_REF (GM_PAGE_LEN);
GM_REF (_gm_assertion_failed);
GM_REF (_gm_get_route);
GM_REF (gm_abort);
GM_REF (gm_alloc_pages);
GM_REF (gm_alloc_send_token);
GM_REF (gm_allow_remote_memory_access);
GM_REF (gm_bcopy);
GM_REF (gm_blocking_receive);
GM_REF (gm_blocking_receive_no_spin);
GM_REF (gm_bzero);
GM_REF (gm_calloc);
GM_REF (gm_cancel_alarm);
GM_REF (gm_close);
GM_REF (gm_crc);
GM_REF (gm_crc_str);
GM_REF (gm_create_hash);
GM_REF (gm_create_lookaside);
GM_REF (gm_create_mark_set);
GM_REF (gm_create_mutex);
GM_REF (gm_datagram_send);
#if GM_ENABLE_PIO_DATAGRAMS
GM_REF (gm_datagram_send_4);
#endif
GM_REF (gm_deregister_memory);
GM_REF (gm_destroy_hash);
GM_REF (gm_destroy_lookaside);
GM_REF (gm_destroy_mark_set);
GM_REF (gm_destroy_mutex);
#if !GM_KERNEL
GM_REF (gm_directcopy_get);
#endif
GM_REF (gm_directed_send);
GM_REF (gm_directed_send_with_callback);
GM_REF (gm_dma_calloc);
GM_REF (gm_dma_free);
GM_REF (gm_dma_malloc);
GM_REF (gm_drop_sends);
GM_REF (gm_dump_buffers);
GM_REF (gm_eprintf);
GM_REF (gm_exit);
GM_REF (gm_finalize);
GM_REF (gm_flush_alarm);
GM_REF (gm_free);
GM_REF (gm_free_pages);
GM_REF (gm_free_send_token);
GM_REF (gm_free_send_tokens);
GM_REF (gm_get);
GM_REF (gm_get_host_name);
GM_REF (gm_get_mapper_unique_id);
GM_REF (gm_get_node_id);
/* GM_REF (gm_get_node_type); No longer supported */
GM_REF (gm_get_port_id);
GM_REF (gm_get_unique_board_id);
GM_REF (gm_getpid);
GM_REF (gm_global_id_to_node_id);
GM_REF (gm_handle_sent_tokens);
GM_REF (gm_hash_compare_ints);
GM_REF (gm_hash_compare_longs);
GM_REF (gm_hash_compare_ptrs);
GM_REF (gm_hash_compare_strings);
GM_REF (gm_hash_find);
GM_REF (gm_hash_hash_int);
GM_REF (gm_hash_hash_long);
GM_REF (gm_hash_hash_ptr);
GM_REF (gm_hash_hash_string);
GM_REF (gm_hash_insert);
GM_REF (gm_hash_rekey);
GM_REF (gm_hash_remove);
GM_REF (gm_hex_dump);
GM_REF (gm_host_name_to_node_id);
GM_REF (gm_host_name_to_node_id_ex);
GM_REF (gm_init);
GM_REF (gm_initialize_alarm);
GM_REF (gm_isprint);
GM_REF (gm_log2_roundup);
GM_REF (gm_log2_roundup_table);
GM_REF (gm_lookaside_alloc);
GM_REF (gm_lookaside_free);
GM_REF (gm_lookaside_zalloc);
GM_REF (gm_malloc);
GM_REF (gm_mark);
GM_REF (gm_mark_is_valid);
GM_REF (gm_max_length_for_size);
GM_REF (gm_max_node_id);
GM_REF (gm_max_node_id_in_use);
GM_REF (gm_max_node_id_inuse);
GM_REF (gm_memcmp);
GM_REF (gm_memorize_message);
GM_REF (gm_memset);
GM_REF (gm_min_message_size);
GM_REF (gm_min_size_for_length);
GM_REF (gm_mtu);
GM_REF (gm_mutex_enter);
GM_REF (gm_mutex_exit);
GM_REF (gm_next_event_peek);
GM_REF (gm_node_id_to_global_id);
GM_REF (gm_node_id_to_host_name);
GM_REF (gm_node_id_to_host_name_ex);
GM_REF (gm_node_id_to_unique_id);
GM_REF (gm_num_ports);
GM_REF (gm_num_receive_tokens);
GM_REF (gm_num_send_tokens);
#if !GM_KERNEL
GM_REF (gm_on_exit);
#endif
GM_REF (gm_open);
GM_REF (gm_page_alloc);
GM_REF (gm_page_free);
GM_REF (gm_perror);
GM_REF (gm_provide_receive_buffer);
GM_REF (gm_provide_receive_buffer_with_tag);
GM_REF (gm_put);
GM_REF (gm_rand);
GM_REF (gm_rand_mod);
GM_REF (gm_receive);
GM_REF (gm_receive_pending);
GM_REF (gm_register_buffer);
GM_REF (gm_register_memory);
GM_REF (gm_register_memory_ex);
GM_REF (gm_resume_sending);
GM_REF (gm_send);
GM_REF (gm_send_to_peer);
GM_REF (gm_send_to_peer_with_callback);
GM_REF (gm_send_token_available);
GM_REF (gm_send_with_callback);
GM_REF (gm_set_acceptable_sizes);
GM_REF (gm_set_alarm);
GM_REF (gm_set_enable_nack_down);
#if !GM_KERNEL
GM_REF (gm_sleep);
#endif
GM_REF (gm_srand);
GM_REF (gm_strcmp);
GM_REF (gm_strdup);
GM_REF (gm_strerror);
GM_REF (gm_strlen);
GM_REF (gm_strncasecmp);
GM_REF (gm_strncmp);
GM_REF (gm_strncpy);
GM_REF (gm_ticks);
GM_REF (gm_unique_id);
GM_REF (gm_unique_id_to_node_id);
GM_REF (gm_unknown);
GM_REF (gm_unmark);
GM_REF (gm_unmark_all);
GM_REF (gm_unregister_buffer);
GM_REF (gm_zone_addr_in_zone);
GM_REF (gm_zone_calloc);
GM_REF (gm_zone_create_zone);
GM_REF (gm_zone_destroy_zone);
GM_REF (gm_zone_free);
GM_REF (gm_zone_malloc);

/* Reference all undocumented entry points, too. */
     
#include "gm_undocumented_funcs.h"

GM_REF (_gm_clear_all_routes);
GM_REF (_gm_clear_counters);
GM_REF (_gm_cop_end);
GM_REF (_gm_cop_receive);
GM_REF (_gm_cop_send);
GM_REF (_gm_cop_wakeup);
/* GM_REF (_gm_dump_receive_queue); */
GM_REF (_gm_enable_raw_receives);
/* GM_REF (_gm_finish_mmap); */
GM_REF (_gm_get_board_config_strings);
GM_REF (_gm_get_build_id);
GM_REF (_gm_get_eeprom);
GM_REF (_gm_get_firmware_string);
#if GM_BUILDING_INTERNALS /* Allow only if struct layouts are compatible. */
GM_REF (_gm_get_globals);
GM_REF (_gm_get_globals_by_request);
#endif
GM_REF (_gm_get_kernel_build_id);
/* GM_REF (_gm_get_mapping_specs); */
GM_REF (_gm_get_opener_pids);
GM_REF (_gm_get_page_hash_cache_size);
GM_REF (_gm_get_page_len);
GM_REF (_gm_get_version);
GM_REF (_gm_handle_alarm);
GM_REF (_gm_handle_flushed_alarm);
GM_REF (_gm_mapper_open);
GM_REF (_gm_max_used_node_id);
/* GM_REF (_gm_nt_foo); */
GM_REF (_gm_preserve_lanai_globals);
GM_REF (_gm_provide_raw_receive_buffer);
GM_REF (_gm_raw_send);
GM_REF (_gm_raw_send_with_callback);
GM_REF (_gm_set_host_name);
/* GM_REF (_gm_set_mapper_level); No longer supported */
GM_REF (_gm_set_node_id);
/* GM_REF (_gm_set_node_type); No longer supported */
GM_REF (_gm_set_opener_pid);
/* GM_REF (_gm_set_port_num); */
GM_REF (_gm_set_route);
GM_REF (_gm_set_unique_id);
GM_REF (_gm_unknown_debug_buffers);
GM_REF (_gm_user_ioctl);
GM_REF (_gm_user_write_lanai_register);

/* Include a function in the object file, because some compilers will
   emit an empty object without it. */

void gm_some_compilers_are_lame (void) 
{
  return;
}

/*
  This file uses GM standard indentation:

  Local Variables:
  c-file-style:"gnu"
  tab-width:8
  End:
*/
