/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation                      *
 * Copyright (c) 1996, 1997 by Myricom, Inc.                             *
 * All rights reserved.  See the file `COPYING' for copyright notice.    *
 *************************************************************************/

/**
   @file gm_send_token_available.c
   This file contains the GM API function gm_send_token_available().
*/

#include "gm_internal.h"

/**
   gm_send_token_available() tests for the availability of a send token
   without allocating the send token.  It is similar to the function
   gm_alloc_send_token(port,priority) without the allocation.
 
   @retval int
 
   @param p \b (IN) The GM port on the source/sender GM node from which
                    the communication would be sent.
 
   @param priority \b (IN) The priority of the message to be sent.
 
   @see gm_alloc_send_token
 
   @author Glenn Brown
 
   @version GM_API_VERSION (as defined in gm.h)
 
*/

int
gm_send_token_available (gm_port_t * p, unsigned priority)
{
  /* gm_assert (GM_MIN_PRIORITY <= priority); */
  gm_assert (priority <= GM_MAX_PRIORITY);

  GM_SIMULATE_SIMULATE ( );

  return p->send_token_cnt[priority];
}
