/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation                      *
 * Copyright (c) 1996, 1997 by Myricom, Inc.                             *
 * All rights reserved.  See the file `COPYING' for copyright notice.    *
 *************************************************************************/

#include "gm_internal.h"

#if GM_KERNEL
#include "gm_enable_security.h"
#include "gm_pio.h"
#include "gm_debug.h"
#endif

GM_ENTRY_POINT
gm_status_t
_gm_set_mapper_state (gm_port_t *port,
		      const struct gm_mapper_state *mapper_state)
{
#if GM_KERNEL
  gm_port_state_t *ps = port->kernel_port_state;
  gm_instance_state_t *is = ps->instance;

  if (GM_ENABLE_SECURITY && !ps->privileged)
    return GM_PERMISSION_DENIED;

  return gm_copyin (ps, (const void *) mapper_state, &is->mapper_state,
		    sizeof (*mapper_state));
#else
  {
    struct gm_mapper_state ms;
    
    /* Copy the data behind the const pointer to a read/write buffer. */
    gm_bcopy (mapper_state, &ms, sizeof (ms));
    return _gm_user_ioctl (port, GM_SET_MAPPER_STATE, &ms, sizeof (ms));
  }
#endif
}
