/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation                      *
 * Copyright (c) 1996, 1997 by Myricom, Inc.                             *
 * All rights reserved.  See the file `COPYING' for copyright notice.    *
 *************************************************************************/

/**
   @file gm_strcmp.c
   This file contains the GM API function gm_strcmp().
*/

#include "gm_internal.h"

/**
 
   gm_strcmp() reimplements strcmp().
 
   @retval int Returns an integer less than, equal to, or greater
     than zero if a is found, respectively, to be less than, to
     match, or be greater than b.
 
   @param a The first string to be compared.

   @param b The second string to be compared.
 
   @author Glenn Brown
 
   @version GM_API_VERSION (as defined in gm.h)
 
*/
 
GM_ENTRY_POINT
int
gm_strcmp (const char *a, const char *b)
{
  int result;
  while (1)
    {
      if (!*a || !*b)
	return *a - *b;
      result = *a++ - *b++;
      if (result)
	return result;
    }
}
