/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation			 *
 * Copyright (c) 2001 by Myricom, Inc.					 *
 * All rights reserved.	 See the file `COPYING' for copyright notice.	 *
 *************************************************************************/

/**
   @file gm_strdup.c
*/

#include "gm.h"

/**

   gm_strdup() reimplements the UNIX function strdup().
 
   @retval char* Returns a pointer to the duplicated string,
         or NULL if insufficient memory was available.
 
   @param in (IN) The string to be duplicated.
 
   @author Glenn Brown
 
   @version GM_API_VERSION (as defined in gm.h)
 
*/

GM_ENTRY_POINT
char *
gm_strdup (const char *in)
{
  gm_size_t len;
  char *ret;
  
  len = gm_strlen (in) + 1;
  ret = gm_malloc (len);
  if (ret)
    {
      gm_strncpy (ret, in, (int) len);
    }
  return ret;
}

/*
  This file uses GM standard indentation.

  Local Variables:
  c-file-style:"gnu"
  tab-width:8
  End:
*/
