/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation			 *
 * Copyright (c) 2000 by Myricom, Inc.					 *
 * All rights reserved.	 See the file `COPYING' for copyright notice.	 *
 *************************************************************************/

/**
   @file gm_strlen.c
   This file contains the GM API function gm_strlen().
*/

#include "gm_internal.h"
#include "gm_debug.h"

#define GM_MAX_STRLEN (1024*1024)

/**
 
   gm_strlen() calculates the length of a string.
 
   @retval gm_size_t The length of the string.
 
   @param cptr (IN) The string.
 
   @author Glenn Brown
 
   @version GM_API_VERSION (as defined in gm.h)
*/
 
GM_ENTRY_POINT
gm_size_t
gm_strlen (const char *cptr)
{
  int i = 0;
  while ((cptr[i]) && (i < GM_MAX_STRLEN))
    {
      i++;
    }
   
  if (i >= GM_MAX_STRLEN)
    {
      GM_WARN (("gm_strlen exceeded GM_MAX_STRLEN\n"));
    }
   
  return i;
}
