/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation                      *
 * Copyright (c) 1996, 1997 by Myricom, Inc.                             *
 * All rights reserved.  See the file `COPYING' for copyright notice.    *
 *************************************************************************/

/**
   @file gm_strncmp.c
   This file contains the GM API function gm_strncmp().
*/

#include "gm_internal.h"

/**
 
   gm_strncmp() reimplements strncmp().

   @retval int Returns an integer less than, equal to, or greater
     than zero if the first len bytes of a is found, respectively, to be 
     less than, to match, or be greater than b.
 
   @param a (IN) The first string to be compared.
 
   @param b (IN) The second string to be compared.

   @param len (IN) The length in bytes. 

   @author Glenn Brown
 
   @version GM_API_VERSION (as defined in gm.h)
*/
 
GM_ENTRY_POINT
int
gm_strncmp (const char *a, const char *b, int len)
{
  int result;
  while (len--)
    {
      if (!*a || !*b)
	return *a - *b;
      result = *a++ - *b++;
      if (result)
	return result;
    }
  return 0;
}
