/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation                      *
 * Copyright (c) 1996, 1997 by Myricom, Inc.                             *
 * All rights reserved.  See the file `COPYING' for copyright notice.    *
 *************************************************************************/

/**
   @file gm_strncpy.c
   This file contains the GM API function gm_strncpy().
*/

#include "gm_config.h"
#include "gm.h"

/**

   gm_strncpy() copies exactly n bytes, truncating src or adding null
   characters to dst if necessary.  The result will not be
   null-terminated if the length of src is n or more.

   @retval char* Returns a pointer to a destination string.

   @param to (IN) The destination string to be copied.

   @param from (IN) The source string to be copied.

   @param len (IN) The number of bytes to be copied.
 
   @author Glenn Brown
 
   @version GM_API_VERSION (as defined in gm.h)
 
*/

GM_ENTRY_POINT
char *
gm_strncpy (char *to, const char *from, int len)
{
  char *orig_to = to;

  while (len--)
    {
      *to++ = *from;
      if (*from)
	from++;
    }

  return orig_to;
}
