#ifndef mi_h
#define mi_h

#include "gm.h"
#include <stdlib.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>

#define mi_u32_t gm_u32_t
#define mi_u8_t gm_u8_t
#define mi_s8_t gm_s8_t
#define mi_u16_t gm_u16_t

mi_u32_t mi_htonl (mi_u32_t x);
mi_u16_t mi_htons (mi_u16_t x);

extern int mi_verbose_flag;
void mi_println_verbose_function (const char*fmt,...);
#define mi_c(p) if (mi_verbose_flag) mi_println_verbose_function p

typedef struct lx_node_t*mi_index_t;
struct lx_node_t;
struct lx_t;

typedef struct buffer_t
{
  void*context;
  char p [LX_SMALL_MTU];

}buffer_t;

#define NUM_SMALLS (LX_NUM_SMALLS + LX_NUM_REPLIES)
#define NUM_RECEIVES 4

typedef struct mi_t
{
  gm_alarm_t gm_alarm;
  struct gm_port *gm_port;
  char gm_address[6];

  buffer_t*bigs [LX_NUM_BIGS];
  buffer_t*smalls [NUM_SMALLS];
  buffer_t*receives [NUM_RECEIVES];
  unsigned big_count, small_count;
  int alarmed;
}mi_t;

typedef struct mi_go_t
{
  struct lx_t*lx;
  int unit;
  int level;
  int clos;
  int check_xbars;
  int map_once;
  int printeur;
}mi_go_t;

void mi_send (struct lx_t*lx, void*route, unsigned route_length, void*p, unsigned length, void*context);
void mi_set_alarm (struct lx_t*lx, unsigned duration);
void mi_set_route (struct lx_t*lx, int index, unsigned char mac_address [6], int host_type, int host_index, signed char*route, unsigned length);
void mi_set_route_begin (struct lx_t*lx);
void mi_set_route_end (struct lx_t*lx);
void mi_get_address (struct lx_t*lx, unsigned char mac_address [6]);
void mi_set_map_version (struct lx_t*lx, unsigned char mac_address [6], unsigned map_version, unsigned num_hosts, int done_everywhere, int valid);

int mi_wait (struct lx_t*lx, void*message, unsigned*length, void*contexts [], int early);

#define mi_index2node(index)index
#define mi_node2index(n)n

void mi_println_map (struct lx_t*lx, const char*fmt,...);

extern void mi_fail (void);
extern int mi_is_demon;
#define insist(e) if(!(e)) {if (!mi_is_demon) printf ("assertion failed. %s:%d (%s)\n", __FILE__,__LINE__, #e); mi_fail (); goto except;}

#define MI_RAND_MAX RAND_MAX
extern int mi_rand (void);
#define mi_memcpy memcpy

unsigned mi_time(struct lx_t*lx);
struct lx_map_t;
struct lx_t;
void mi_dump_map (struct lx_t*lx, struct lx_map_t*m);
#define mi_match(a,b)1
#define mi_punt(lx)
#define mi_printeur_lx 0

void mi_go (struct lx_t*lx, int unit);

#endif /*mi_h*/
