/*
  fc_Calculator.h
  simple calculator
  finucane@myri.com (David Finucane)
*/

#ifndef fc_Calculator_h
#define fc_Calculator_h

#include "mt_Route.h"
#include "mt_Calculator.h"
#include "mt_RouteTable.h"

class fc_Calculator : public mt_Calculator
{
  private:
  char filename [mt_File::FILENAME_LENGTH + 1];
  mt_RouteTable*routeTable;
  
  int initialize ();
  
  public:
  fc_Calculator();
  ~fc_Calculator();
  
  virtual void cleanup ();
  virtual int getRoute (int from, int to, int routeIndex, mt_Route*route);
  virtual int getMaxRoutes ();
  virtual int getNumRoutes (int from, int to);
  virtual mt_Node*newNode (int nodeType, char*name, char*type);
  virtual void usage ();
  virtual int parseArgs (mt_Args*args);
  virtual int initialize (mt_Graph*graph, mt_Node*root);
  virtual int initialize (char*mapFile);
};

#endif /*fc_Calculator_h*/
