/*
 AllTest.java
  Merlyn
  (c) 1997 Myricom, Inc.
  finucane@myri.com (David Finucane)
*/

import java.io.*;
import java.util.*;

class AllTest
{
  private int ints[][];
  String names[];
  Hashtable indexes;
  
 
  public int getHostCount ()
  {
    return names.length;
  }
  public AllTest (String filename) throws Exception
  {
    LineNumberReader r = new LineNumberReader (new FileReader (filename));

    int leading = 0;

    int numHosts = 0;
    /*eat the leading crap*/
    for (String s = r.readLine (); s != null; s = r.readLine (), leading++)
    {
      s = s.trim();
      if (s.length() == 0)
	continue;
      
      numHosts = Integer.valueOf (s).intValue();
      break;
    }
    
    ints = new int [numHosts][numHosts];
    names = new String [numHosts];
    indexes = new Hashtable (numHosts);
    indexes.clear();
    
    int i;
    for (i = 0; i < numHosts; i++)
    {
      String line = r.readLine ();
      if (line == null)
	break;
      StringTokenizer st = new StringTokenizer (line);
      
      for (int j = 0; st.hasMoreTokens () && j < numHosts; j++)
      {
	try
	  {
	    ints [i][j] = Integer.parseInt (st.nextToken());
	  }
	catch (NumberFormatException e)
	  {
	    System.out.println ("error on line " + (leading + i));
	    names = new String [0];
	    return;
	  }
      }
      names[i] = st.nextToken();
      if (names[i] == null)
	break;
      names[i]= names[i].trim();
      indexes.put (names[i], new Integer (i));
    }
    if (i != numHosts)
    {
      System.out.println ("error on line " + (leading + i));
      names = new String [0];
    }
  }
  public int getErrorCount (int from, int to)
  {
    return ints [to][from];
  }
  public String getName (int index)
  {
    return names [index];
  }
  
  public int getErrorCount (String from, String to)
  {
    int fn = ((Integer) indexes.get (from)).intValue();
    int tn = ((Integer) indexes.get (to)).intValue();

    return getErrorCount (tn, fn);
  }
}








