/*
  sc_Host.h
  simple calculator
  finucane@myri.com (David Finucane)
*/

#ifndef sc_Host_h
#define sc_Host_h

#include "mt_Host.h"
#include "mt_Route.h"

class sc_Host : public mt_Host
{
  private:
  int numRoutes;
  int maxRoutes;
  mt_Route*routes;
  int*costs;
  
  public:
  sc_Host (char*name, char*type, int maxRoutes);
  ~sc_Host ();
  int getNumRoutes ();
  int addRoute (const mt_Route&r, int cost, mt_Route*old = 0);
  virtual mt_Route*getRoute (int n);
  virtual void setRoute (int n, const mt_Route&r);
  int replaceRoute (int n, mt_Route*r);
  void clearRoutes ();
};


#endif /*sc_Host_h*/
