/*
  st_Mapper.c
  myricom mapper
  finucane@myri.com (David Finucane)
*/

#ifndef st_Mapper_h
#define st_Mapper_h

#include "mt_Mapper.h"
#include "mt_HostTable.h"
#include "mt_Queue.h"

#include "st_Simulation.h"
#include "mt_Graph.h"
#include "mt_MapperOptions.h"

class st_Mapper : public mt_Mapper
{
  private:
  mt_Graph*makeGraph (char*filename);

  public:
  st_Mapper (mt_Node*node, mt_Network*network, mt_Calculator*calculator, mt_MapperOptions&options);
  virtual ~st_Mapper ();
  virtual mt_Node*newNode (int nodeType, char*name, char*type);
  virtual void callHandler (int type, mt_Message*m, int length);
  virtual void dump (FILE*fp);
  virtual int start ();
};


#endif /*st_Mapper_h*/
