/*
  merge_routes.c
  to merge route files into 1.
  finucane@myri.com
*/

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include "mt_RouteTable.h"
#include "mt_MapFile.h"

#define die(s){mt_Component::printFormat s; exit (1);}

static void printLine (char*s)
{
  printf ("%s\n", s);
}

int main (int argc, char*argv [])
{
  mt_Component::initialize (printLine);
  mt_RouteTable*routes = 0;
  mt_RouteFile rf (stdout);
  
  if (argc < 4)
    die (("usage: %s <mapfile> <routefile> <routefile> [...]", argv [0]));
  
  char*mapFile = argv[1];
  
  mt_MapFile mf (mapFile, mt_File::_READ);
  mt_Graph g;

  if (!mf.read (&g))
    die (("main: couldn't parse map file %s", mapFile));

  routes = new mt_RouteTable;
  if (!routes)
    die (("couldn't alloc route table"));

  if (!routes->fromFile (argv [2], &g))
    die (("couldn't parse routes file %s", argv [2]));

  for (int i = 3; i < argc; i++)
  {
    mt_RouteTable r;
    mt_RouteTable*rt;
    rt = new mt_RouteTable;
    if  (!rt)
      die (("couldn't alloc route table"));

    if (!r.fromFile (argv [i], &g))
      die (("couldn't parse routes file %s", argv [i]));

    if (!rt->fromTables (&g, routes, &r))
      die (("couldn't merge with route file %s", argv [i]));
    
    mt_RouteTable*t;
    t = routes;
    routes = rt;
    delete t;
  }
  rf.write (&g, routes);
}
