### Modify all #includes of GM files to include the preprocessed version.
### Also, redefine __GM_FILE__ after the inclusion.

/^[ 	]*#[ 	]*include[ 	]*"\(.*\)\.\([ch]\)"/ {
s/^[ 	]*#[ 	]*include[ 	]*"\(.*\)\.\([ch]\)"\(.*\)/#include "\1.\2.\2"\3\
\%%SKIP%%#undef __GM_FILE__\
\%%SKIP%%#define __GM_FILE__ "___GM_FILE___"\
\%%LINENO%%/
}

### define __GM_FUNCTION__ at the start of each function

/^[a-zA-Z_][a-zA-Z_0-9]*[ 	]*([^;\\]*$/ {
s/^\([a-zA-Z_][a-zA-Z_0-9]*\)\([ 	]*([^;\\]*\)$/\1\2\
\%%SKIP%%#undef GM_FUNCTION\
\%%SKIP%%#define GM_FUNCTION \1\
\%%SKIP%%#undef __GM_FUNCTION__\
\%%SKIP%%#define __GM_FUNCTION__ "\1"\
\%%LINENO%%/
}

### Undefine __GM_FUNCTION__ at the end of the function.  This also undefines
### it at the end of any top-level typedefs, but that's OK.

/^}[^\\]*$/ {
s/^\(}[^\\]*\)$/\1\
\%%SKIP%%#undef GM_FUNCTION\
\%%SKIP%%#define GM_FUNCTION GM_UNKNOWN_FUNCTION\
\%%SKIP%%#undef __GM_FUNCTION__\
\%%SKIP%%#define __GM_FUNCTION__ __GM_UNKNOWN_FUNCTION__\
\%%LINENO%%/
}

# Output new line number information at the end of each #endif, 
# in case a #line correction was somehow disabled by being inside an
# #if.

/^#endif/ {
s/^\(#endif.*\)$/\1\
\%%LINENO%%/
}
