#include <stdio.h>
#include <stdlib.h>
#include "gm_internal.h"
#include "gm.h"

static int
gm_poke_lanai (int argc, char *argv[])
{
  gm_status_t status;
  gm_u32_t offset;
  gm_u32_t value;
  struct gm_port* port;
  unsigned int unit;
  

  if (argc != 4) {
    printf ("usage: %s board_num magic_1 magic_2\n", argv[0]);
    exit (EXIT_FAILURE);
  }

  unit = strtoul (argv[1], NULL, 10);
  offset = (gm_u32_t) strtoul (argv[2], NULL, 16);
  value = (gm_u32_t) strtoul (argv[3], NULL, 16);

  if (_gm_mapper_open (&port, unit,
                       (enum gm_api_version) GM_API_VERSION)
      != GM_SUCCESS)
    {
      printf ("_gm_mapper_open failed\n");
      exit (EXIT_FAILURE);
    }

  status = _gm_user_write_lanai_register (port, offset, value);
  if (status != GM_SUCCESS)
    {
      printf ("_gm_user_write_lanai_register() failed\n");
      exit (EXIT_FAILURE);
    }

  gm_close(port);

  return EXIT_SUCCESS;
}

#define GM_MAIN gm_poke_lanai
#include "gm_main.h"
