/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation			 *
 * Copyright (c) 1999 by Myricom, Inc.					 *
 * All rights reserved.	 See the file `COPYING' for copyright notice.	 *
 *************************************************************************/

/*
 * This program is used in conjunction with a preprocessor that
 * inserts gunk into a file, but wants to maintain the original line
 * numbers.  Each inserted line is prefixed with Skip_prefix, and
 * the places where we should indicate the line number contain Lino_no
 * We strip off the Skip_prefix, and replace Line_no indicators with
 * cpp #line directives.
 *
 * e.g. For input:
 *	func()
 *	%%SKIP%%#define __GM_FUNCTION__ "func"
 *      %%LINENO%% "filename"
 *      {
 *  we should output:
 *      func()
 *      #define  __GM_FUNCTION__ "func"
 *      #line 2 "filename"
 *      {
 *
 */
#include <stdio.h>

int strncmp(char *, char *, int);

char Skip_prefix[] = "%%SKIP%%";
char Line_no[] = "%%LINENO%%";

int
main(
  int argc,
  char **argv)
{
  char buf[1024];
  int line_no;

  /* Output a little prologue... */
  fprintf(stdout, "#undef __GM_FILE__\n");
  fprintf(stdout, "#define __GM_FILE__ \"___GM_FILE___\"\n");
  if (argc > 1)
    {
      fprintf(stdout, "#line 1 \"%s\"\n", argv[1]);
    }
   else
    {
      fprintf(stdout, "#line 1 \n");
    }


  line_no = 1;
  while (fgets(buf, sizeof(buf), stdin) != NULL)
    {

      if (strncmp(buf, Skip_prefix, sizeof(Skip_prefix)-1) == 0)
	{
	  fputs(buf + sizeof(Skip_prefix)-1, stdout);
	  continue;
	}

      if (strncmp(buf, Line_no, sizeof(Line_no)-1) == 0)
	{
	  fprintf(stdout, "#line %d %s", line_no, buf + sizeof(Line_no)-1);
	  continue;
	}

      fputs(buf, stdout);
      ++line_no;
    }

  return 0;
}

/*
  This file uses GM standard indentation:

  Local Variables:
  c-file-style:"gnu"
  tab-width:8
  End:
*/
